# -*- coding: utf8 -*-

import mod_mysql, sys, time, urllib2
import subeFlickr

import infodb
dbusr,dbclv = infodb.get()
bdd = mod_mysql.DataBase("localhost", dbusr, dbclv, "tanique_plog")

BASEIMG = "http://www.taniquetil.com.ar/facundo/imgs/"

archlog = open("llevaImgs.log", "a")
archlog.write("\n")
def log(texto):
    archlog.write("%s - %s\n" % (time.ctime(), texto))
    archlog.flush()

def subeFoto(urlorigen, artid, nro, topic):
    u = urllib2.urlopen(urlorigen)
    img = u.read()
    try:
        titulo = urlorigen.split("/")[-1].split(".")[0]
    except:
        titulo = repr(urlorigen)
    print (urlorigen, artid, nro, topic)
    descrip = "Post %d (img %d) %s [http://www.taniquetil.com.ar/plog/post/1/%d]" % (artid, nro, topic, artid)
    urlnueva = subeFlickr.lleva(img, titulo, descrip)
    return urlnueva.encode("latin1")

def main(dias):
    antes = time.localtime(time.time()-dias*24*3600)
    fechalimite = time.strftime("%Y-%m-%d", antes)
    log("Arrancamos, buscando %d dias para atras, antes del '%s'" % (dias, fechalimite))

    res = bdd.accion("select article_id, date, text, topic from plog_articles inner join plog_articles_text on plog_articles.id=plog_articles_text.article_id where date<'%s';" % fechalimite)
    log("Encontramos %d articulos" % len(res))

    articulos = [x for x in res if BASEIMG in x[2]]
    log("Tenemos %d articulos para modificar" % len(articulos))

    for (artid, date, text, topic) in articulos:
        # guardamos por las dudas
        log("Procesando articulo %d: %s (%s)" % (artid, topic, date))
        arch = open("backup_%s.txt" % artid, "w")
        arch.write(text)
        arch.close()
    
        topic = topic.decode("latin1").encode("ascii", "replace")
        # cambiamos todas las imágenes que haya
        cant = 0
        while BASEIMG in text:
            posini = text.index(BASEIMG)
            caracterlimite = text[posini-1]
            posfin = text.index(caracterlimite, posini)
    
            urlantes = text[posini:posfin]
            cant += 1
            log("  URL encontrada: %r" % urlantes)
            urlnueva = subeFoto(urlantes, artid, cant, topic)
            text = text[:posini] + urlnueva + text[posfin:]
            log("  URL nueva: %r" % urlnueva)
        log("Reemplazamos %d URLs" % cant)

        text = text.replace("'", "\\'")
        bdd.accion("update plog_articles_text set text='%s' where article_id=%d" % (text, int(artid)))
        log("Update bdd ok")

if __name__ == "__main__":
    if len(sys.argv) != 2:
        print "Usar: llevaImgs.py <dias>     el sistema llevará a Flickr las imagenes con mas de <dias> de antigüedad"
        sys.exit()

    main(int(sys.argv[1]))
